var diameter = .8;
var foreground = [1., .1, .1, 0];
var background = [.9, .9, .9, 1];

if(jsarguments.length > 3)
	foreground = [jsarguments[1]/255., jsarguments[2]/255., jsarguments[3]/255., 0];
if(jsarguments.length > 6)
	background = [jsarguments[5]/255., jsarguments[6]/255., jsarguments[7]/255., 1];
if(jsarguments.length > 7)
	diameter = jsarguments[9];

var state = 0;
var last_x, last_y;
var basestate;

draw();

function draw() {
	foreground[3] = state;
	with (sketch) {
		glclearcolor(background);
		glclear();			
		moveto(0,0);

		glcolor(foreground);
		circle(diameter);
	}
	outlet(0, state);
	refresh();
}

function msg_float(v) {
	state = v;
	draw();
}

function setcolor(r, g, b) {
	foreground = [r / 255., g / 255., b / 255., state];
	draw();
}

function setbgcolor(r, g, b) {
	background = [r / 255., g / 255., b / 255., 1.];
	draw();
}

function setdiameter(v) {
	diameter = v;
	draw();
}

function onclick(x,y,but,cmd,shift,capslock,option,ctrl) {
	// cache mouse position for tracking delta movements
	last_x = x;
	last_y = y;
	basestate = state;
	state = state == 0 ? 1 : 0;
	draw();	
}

function ondrag(x,y,but,cmd,shift,capslock,option,ctrl)
{
	var m = 100;	
	// calculate delta movements
	var dx = x - last_x;

	if (shift){
		m = 500;
	}

	if (but == 2) { 
		// change intensity if right-clicked
		state = basestate + dx/m;
		if(state < 0) {
			state = 0;
		} 
		else if (state > 1) {
			state = 1;
		}
		draw();
	}
}